<?php

class WoodBerry_Customizer {

    public static function WoodBerry_Register($wp_customize) {
        self::WoodBerry_Sections($wp_customize);
        self::WoodBerry_Controls($wp_customize);
    }

    public static function WoodBerry_Sections($wp_customize) {
        /**
         * General Section
         */
        $wp_customize->add_section('general_setting_section', array(
            'title' => __('General Settings', 'woodberry'),
            'description' => __('Allows you to customize header logo, favicon, background etc settings for WoodBerry Theme.', 'woodberry'), //Descriptive tooltip
            'panel' => '',
            'priority' => '10',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Home Page Top Feature Area
         */
        $wp_customize->add_section('home_top_feature_area', array(
            'title' => __('Top Feature Area', 'woodberry'),
            'description' => __('Allows you to setup Top feature area section for WoodBerry Theme.', 'woodberry'), //Descriptive tooltip
            'panel' => '',
            'priority' => '11',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Add panel for home page feature area
         */
        $wp_customize->add_panel('home_page_feature_area_panel', array(
            'title' => __('Home Page Feature Area', 'woodberry'),
            'description' => __('Allows you to setup home page feature area section for WoodBerry Theme.', 'woodberry'),
            'priority' => '12',
            'capability' => 'edit_theme_options'
        ));
        /**
         * Home Page feature area 1
         */
        $wp_customize->add_section('home_feature_area_section1', array(
            'title' => __('First Feature Area', 'woodberry'),
            'description' => __('Allows you to setup first feature area section for WoodBerry Theme.', 'woodberry'),
            'panel' => 'home_page_feature_area_panel',
            'priority' => '',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Home Page feature area 2
         */
        $wp_customize->add_section('home_feature_area_section2', array(
            'title' => __('Second Feature Area', 'woodberry'),
            'description' => __('Allows you to setup second feature area section for WoodBerry Theme.', 'woodberry'),
            'panel' => 'home_page_feature_area_panel',
            'priority' => '',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Home Page feature area 3
         */
        $wp_customize->add_section('home_feature_area_section3', array(
            'title' => __('Third Feature Area', 'woodberry'),
            'description' => __('Allows you to setup third feature area section for WoodBerry Theme.', 'woodberry'),
            'panel' => 'home_page_feature_area_panel',
            'priority' => '',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Home Page Feature area setting
         */
        $wp_customize->add_section('home_page_blog_headings', array(
            'title' => __('Home Page Blog Headings', 'woodberry'),
            'description' => __('Allows you to setup Blog heading Section for WoodBerry Theme.', 'woodberry'),
            'panel' => '',
            'priority' => '13',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Social Icon Section
         */
        $wp_customize->add_section('social_icon_section', array(
            'title' => __('Social Icons', 'woodberry'),
            'description' => __('Allows you to setup social site link for WoodBerry Theme.', 'woodberry'),
            'panel' => '',
            'priority' => '14',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Style Section
         */
        $wp_customize->add_section('style_section', array(
            'title' => __('Style Setting', 'woodberry'),
            'description' => __('Allows you to setup Top Footer Section Text for WoodBerry Theme.', 'woodberry'),
            'panel' => '',
            'priority' => '15',
            'capability' => 'edit_theme_options'
                )
        );
        /**
         * Footer Section
         */
        $wp_customize->add_section('footer_settings', array(
            'title' => __('Footer Settings', 'woodberry'),
            'description' => __('Allows you to change style using custom css for WoodBerry Theme.', 'woodberry'),
            'panel' => '',
            'priority' => '16',
            'capability' => 'edit_theme_options'
                )
        );
    }

    public static function WoodBerry_Section_Content() {

        $section_content = array(
            'general_setting_section' => array(
                'woodberry_logo',
                'woodberry_favicon',
            ),
            'home_top_feature_area' => array(
                'woodberry_image1',
                'woodberry_slider_heading1',
                'woodberry_slider_btnlink1',
                'woodberry_slider_des1',
                'woodberry_slider_btnt1'
            ),
            'home_page_blog_headings' => array(
                'woodberry_page_head'
            ),
            'style_section' => array(
                'woodberry_customcss'
            )
        );
        return $section_content;
    }

    public static function WoodBerry_Settings() {
        $woodberry_settings = array(
            'woodberry_logo' => array(
                'id' => 'woodberry_options[woodberry_logo]',
                'label' => __('Custom Logo', 'woodberry'),
                'description' => __('Choose your own logo. Optimal Size: 300px Wide by 90px Height.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'image',
                'default' => get_template_directory_uri() . '/images/logo.png'
            ),
            'woodberry_favicon' => array(
                'id' => 'woodberry_options[woodberry_favicon]',
                'label' => __('Custom Favicon', 'woodberry'),
                'description' => __('Here you can upload a Favicon for your Website. Specified size is 16px x 16px.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'image',
                'default' => ''
            ),
            'woodberry_image1' => array(
                'id' => 'woodberry_options[woodberry_image1]',
                'label' => __('Top Feature Image', 'woodberry'),
                'description' => __('Choose your image or video. Optimal size is 445px wide and height 296px', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'image',
                'default' => get_template_directory_uri() . '/images/slider-image.png'
            ),
            'woodberry_slider_heading1' => array(
                'id' => 'woodberry_options[woodberry_slider_heading1]',
                'label' => __('WordPress theme!', 'woodberry'),
                'description' => __('Enter your text heading for feature.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Create Exciting E-commerce Website', 'woodberry')
            ),
            'woodberry_slider_btnlink1' => array(
                'id' => 'woodberry_options[woodberry_slider_btnlink1]',
                'label' => __('Link for Top Feature Image', 'woodberry'),
                'description' => __('Mention the URL for first image.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'link',
                'default' => '#'
            ),
            'woodberry_slider_des1' => array(
                'id' => 'woodberry_options[woodberry_slider_des1]',
                'label' => __('Feature Description', 'woodberry'),
                'description' => __('Enter your text description for feature.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('WordPress Themes with Single Click Installation, Just a Click and your website is ready for use. Your Site is faster to built, easy to use & Search Engine Optimized.', 'woodberry')
            ),
            'woodberry_slider_btnt1' => array(
                'id' => 'woodberry_options[woodberry_slider_btnt1]',
                'label' => __('Link Text for Top Feature', 'woodberry'),
                'description' => __('Enter your text description for feature button.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Buy Now', 'woodberry')
            ),
            'woodberry_page_head' => array(
                'id' => 'woodberry_options[woodberry_page_head]',
                'label' => __('Main Feature Heading', 'woodberry'),
                'sanitize_callback' => 'wp_kses_post',
                'description' => __('Enter your text for Page Heading.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => __('Now all you have to do, is edit the text and add your own images & Your Website is READY.', 'woodberry')
            ),
            'woodberry_customcss' => array(
                'id' => 'woodberry_options[woodberry_customcss]',
                'label' => __('Custom CSS', 'woodberry'),
                'description' => __('Quickly add your custom CSS code to your theme by writing the code in this block.', 'woodberry'),
                'type' => 'option',
                'setting_type' => 'textarea',
                'default' => ''
            )
        );
        return $woodberry_settings;
    }

    public static function WoodBerry_Controls($wp_customize) {
        $sections = self::WoodBerry_Section_Content();
        $settings = self::WoodBerry_Settings();
        foreach ($sections as $section_id => $section_content) {
            foreach ($section_content as $section_content_id) {
                switch ($settings[$section_content_id]['setting_type']) {
                    case 'image':
                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodberry_sanitize_url');
                        $wp_customize->add_control(new WP_Customize_Image_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id']
                                )
                        ));
                        break;
                    case 'text':
                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodberry_sanitize_text');
                        $wp_customize->add_control(new WP_Customize_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id'],
                            'type' => 'text'
                                )
                        ));
                        break;
                    case 'textarea':
                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodberry_sanitize_textarea');

                        $wp_customize->add_control(new WP_Customize_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id'],
                            'type' => 'textarea'
                                )
                        ));
                        break;
                    case 'link':

                        self::add_setting($wp_customize, $settings[$section_content_id]['id'], $settings[$section_content_id]['default'], $settings[$section_content_id]['type'], 'woodberry_sanitize_url');

                        $wp_customize->add_control(new WP_Customize_Control(
                                $wp_customize, $settings[$section_content_id]['id'], array(
                            'label' => $settings[$section_content_id]['label'],
                            'description' => $settings[$section_content_id]['description'],
                            'section' => $section_id,
                            'settings' => $settings[$section_content_id]['id'],
                            'type' => 'text'
                                )
                        ));

                        break;
                    default:
                        break;
                }
            }
        }
    }

    public static function add_setting($wp_customize, $setting_id, $default, $type, $sanitize_callback) {
        $wp_customize->add_setting($setting_id, array(
            'default' => $default,
            'capability' => 'edit_theme_options',
            'sanitize_callback' => array('WoodBerry_Customizer', $sanitize_callback),
            'type' => $type
                )
        );
    }

    /**
     * adds sanitization callback funtion : textarea
     * @package WoodBerry
     */
    public static function woodberry_sanitize_textarea($value) {
        $array = wp_kses_allowed_html('post');
        $allowedtags = array(
            'iframe' => array(
                'width' => array(),
                'height' => array(),
                'frameborder' => array(),
                'scrolling' => array(),
                'src' => array(),
                'marginwidth' => array(),
                'marginheight' => array()
            )
        );
        $data = array_merge($allowedtags, $array);
        $value = wp_kses($value, $data);
        return $value;
    }

    /**
     * adds sanitization callback funtion : url
     * @package WoodBerry
     */
    public static function woodberry_sanitize_url($value) {
        $value = esc_url($value);
        return $value;
    }

    /**
     * adds sanitization callback funtion : text
     * @package WoodBerry
     */
    public static function woodberry_sanitize_text($value) {
        $value = sanitize_text_field($value);
        return $value;
    }

    /**
     * adds sanitization callback funtion : email
     * @package WoodBerry
     */
    public static function woodberry_sanitize_email($value) {
        $value = sanitize_email($value);
        return $value;
    }

    /**
     * adds sanitization callback funtion : number
     * @package WoodBerry
     */
    public static function woodberry_sanitize_number($value) {
        $value = preg_replace("/[^0-9+ ]/", "", $value);
        return $value;
    }

}

// Setup the Theme Customizer settings and controls...
add_action('customize_register', array('WoodBerry_Customizer', 'WoodBerry_Register'));

function inkthemes_registers() {
    wp_register_script('inkthemes_jquery_ui', '//code.jquery.com/ui/1.11.0/jquery-ui.js', array("jquery"), true);
    wp_register_script('inkthemes_customizer_script', get_template_directory_uri() . '/functions/js/inkthemes_customizer.js', array("jquery", "inkthemes_jquery_ui"), true);
    wp_enqueue_script('inkthemes_customizer_script');
    wp_localize_script('inkthemes_customizer_script', 'ink_advert', array(
        'pro' => __('View PRO version', 'woodberry'),
        'url' => esc_url('http://www.inkthemes.com/wp-themes/simplest-wordpress-theme/'),
        'support_text' => __('Need Help!', 'woodberry'),
        'support_url' => esc_url('http://www.inkthemes.com/lets-connect/')
            )
    );
}

add_action('customize_controls_enqueue_scripts', 'inkthemes_registers');
