<?php
/**
 * The Template for displaying all single posts.
 *
 * 
 */
get_header();
?>
<div class="page-content-container">
    <div class="container_24">
        <div class="grid_24">
            <div class="page-content">
                <div class="grid_16 alpha">
                    <div class="content-bar">
                        <!-- Start the Loop. -->
                        <?php if (have_posts()) : while (have_posts()) : the_post(); ?>
                                <div class="post">
                                    <h1 class="post_title"><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php printf(__('Permanent Link to %s', 'woodberry'), the_title_attribute('echo=0')); ?>"><?php the_title(); ?></a></h1>
                                    <ul class="post_meta">
                                        <li class="posted_by"><span>&nbsp;<?php the_author_posts_link(); ?></span></li>
                                        <li class="post_date"><span><?php _e('on', 'woodberry'); ?>&nbsp;<?php echo get_the_time('M, d, Y') ?></span></li>
                                        <li class="post_category">&nbsp;&nbsp;<?php _e('Category', 'woodberry'); ?>&nbsp;<span><?php the_category(', '); ?></span></li>
                                        <li class="postc_comment"><span>&nbsp;<?php comments_popup_link(__('No Comments.', 'woodberry'), __('1 Comment.', 'woodberry'), __('% Comments.', 'woodberry')); ?></span></li>
                                    </ul>
                                    <div class="post_content"> 
                                        <?php the_content(); ?>
                                        <div class="clear"></div>
                                        <?php if (has_tag()) { ?>
                                            <div class="tag">
                                                <?php the_tags('Post Tagged with ', ', ', ''); ?>
                                            </div>
                                        <?php } ?>
                                    </div>
                                </div>
                                <div class="clear"></div>
                                <?php wp_link_pages(array('before' => '<div class="clear"></div><div class="page-link"><span>' . __('Pages:', 'woodberry') . '</span>', 'after' => '</div>')); ?>
                                <nav id="nav-single"> <span class="nav-previous">
                                        <?php previous_post_link('%link', __('<span class="meta-nav">&larr;</span> Previous Post ', 'woodberry')); ?>
                                    </span> <span class="nav-next">
                                        <?php next_post_link('%link', __('Next Post <span class="meta-nav">&rarr;</span>', 'woodberry')); ?>
                                    </span> </nav>
                                <!--End post-->
                                <?php
                            endwhile;
                        endif;
                        ?>
                        <!--End Loop-->

                        <!--Start Comment box-->
                        <?php comments_template(); ?>
                        <!--End Comment box-->
                    </div>
                </div>
                <div class="grid_8 omega">
                    <!--Start Sidebar-->
                    <?php get_sidebar(); ?>
                    <!--End Sidebar-->
                </div>
            </div>
        </div>
        <div class="clear"></div>
    </div>
</div>
<?php get_footer(); ?>